<?php
/*
   +----------------------------------------------------------------------+
   | Gauge box (progress bar)                                             |
   +----------------------------------------------------------------------+
   | Copyright (c) 1998-2003 Zend Technologies Ltd.                       |
   +----------------------------------------------------------------------+
   | The contents of this source file is the sole property of             |
   | Zend Technologies Ltd.  Unauthorized duplication or access is        |
   | prohibited.                                                          |
   +----------------------------------------------------------------------+
   | Authors: Michael Spector <michael@zend.com>                          |
   |          Anya Tarnyavsky <anya@zend.com>                             |
   +----------------------------------------------------------------------+
   | Tips:                                                                |
   | 1) If you want to find some function - search it with uppercase      |
   |                                                                      |
   +----------------------------------------------------------------------+
*/

class Gaugebox
{
	var $fp;      /* file descriptor to dialog */
	var $msg;     /* default message */
	var $percent; /* default percent */
	var $max_x;   /* width */
	var $max_y;   /* height */

	var $shtu4ka = array(
			0 => '\\ ',
			1 => '| ',
			2 => '/ ',
			3 => '--'
			);

	function Gaugebox($dialog, $max_x, $max_y, $msg, $percent=0, $title="")
	{
		error_reporting(0);

		$this->dialog = $dialog;
		$this->msg = $msg;
		$this->percent = $percent;
		$this->max_x = empty($max_x)? 78 : $max_x;
		$this->max_y = empty($max_y)? 24 : $max_y;

		if(!empty($this->dialog)){

			if(defined('DBUILDER')){
				$this->dialog->scale($title, $msg, 100);
			}
			else{
				$dialog_cmd = "$this->dialog --gauge \"$this->msg\" $this->max_y $this->max_x 0";
				$this->fp = popen($dialog_cmd, "w");
			}
		}

		if(empty($this->dialog)){
			print("$this->msg\n\n");
		}
	}

	// UPDATE
	function update($msg, $percent)
	{
		if(!empty($this->dialog)){ /* GUI */

			if(defined('DBUILDER')){
				$this->dialog->scale_update($percent, $msg);
			}
			else{
				fwrite($this->fp, "XXX\n"); fflush($this->fp);
				fwrite($this->fp, "$percent\n"); fflush($this->fp); /* update percent */
				fwrite($this->fp, "$msg\n"); fflush($this->fp); /* update message */
				fwrite($this->fp, "XXX\n"); fflush($this->fp);
			}
		}
		else{ /* TEXT */
			printf("%-50s  %2s [%d%%]             \r", $msg, $this->shtu4ka[$percent % 4], $percent);
		}
	}

	// CLOSE
	function close()
	{
		if(!empty($this->dialog)){
			if(defined('DBUILDER')){
				$this->dialog->scale_close();
			}
			else{
				pclose($this->fp);
			}
		}
		else{
			print("\n");
		}
	}
}

?>
